#
# bootdisk_gui.py: gui bootdisk creation dialog
#
# Copyright 2001 Red Hat, Inc.
#
# This software may be freely redistributed under the terms of the GNU
# library public license.
#
# You should have received a copy of the GNU Library Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import os
import string
import time
import iutil
import gui
import htmlbuffer
from iw_gui import *
import gtk
from rhpl.log import *
from rhpl.translate import N_, _
from constants import *
from gui import TextViewBrowser

class AgreementWindow (InstallWindow):

    htmlTag = ("agreement")
    windowTitle = None 
    windowRow = 122

    def __init__ (self, ics):
	InstallWindow.__init__ (self, ics)
	self.ics = ics
	ics.setNextEnabled (0)

    def getNext (self):
        if self.yesbutton.get_active ():
	    pass
	else:
	    rc = self.intf.messageWindow(_("Warning"), 
	       _("The installation hasn't "
	       "finished. Did you want to quit the installation?\n"
		"Click \"YES\" to exit, click \"NO\" to continue."), 
		type = "yesno", default="no")

	    if rc == 1:
		gtk.mainquit ()
	    else:
		raise gui.StayOnScreen

    def getPrev(self):
   	self.ics.setNextButton('gtk-go-forward', _("_Next"))
	self.dispatch.id.accept = -1
	self.ics.cw.update(self.ics)

    def nobuttonCallback(self, widget, *args):
	if self.nobutton.get_active():
	    self.dispatch.id.accept = 0
	    self.ics.setNextButton('gtk-quit', _("_Exit"))
	    if self.ics.getNextEnabled() == gtk.TRUE:
	        self.ics.cw.update(self.ics)
	    else:
	        self.ics.setNextEnabled (gtk.TRUE)

    def yesbuttonCallback(self, widget, *args):
	if self.yesbutton.get_active():
	    self.dispatch.id.accept = 1
   	    self.ics.setNextButton('gtk-go-forward', _("_Next"))
	    if self.ics.getNextEnabled() == gtk.TRUE:
	        self.ics.cw.update(self.ics)
	    else:
	        self.ics.setNextEnabled (gtk.TRUE)

    def loadAgreement(self):
	getFlag = 0
        langName = self.id.instLanguage.getCurrent()
        langName = self.id.instLanguage.getLangNick(langName)
	lang = []
	lang = string.split(langName, ".")
	lang = string.split(lang[0], "_")
	if (lang[0] == 'zh' or lang[0] == 'pt'):
		lang[0] = lang[0] + '_' + lang[1]
        if lang[0] == 'en':
            lang[0] = None

        flag = None
	sourcepath = self.dispatch.method.getSourcePath()
        if sourcepath == None:
            try:
                self.dispatch.method.mountMedia(1)
                sourcepath = self.dispatch.method.getSourcePath()
                flag = 'mount'
            except:
                pass

        suffixList = []
        if lang[0]:
            suffixList.append(".%s" % (lang[0],))
            suffixList.append("-%s.html" % (lang[0],))
        else:
            suffixList.append("")
            suffixList.append(".html")

        for suffix in suffixList:
            fn = "%s/Documents/EULA%s" % (sourcepath, suffix)
	    log("read file %s", fn)
            if os.access(fn, os.R_OK):
                file = open(fn, "r")
                if suffix.endswith('.html'):
                    buffer = htmlbuffer.HTMLBuffer()
                    buffer.feed(file.read())
                    self.releaseNotesBuffer = buffer.get_buffer()
                else:
                    buffer = gtk.TextBuffer(None)
                    buffer.set_text(file.read())
                    self.releaseNotesBuffer = buffer
                file.close()
		getFlag = 1
		break
            else:
                import urllib2
		try:
                    url = self.dispatch.method.baseUrl
		except:
		    log("Can not find agreement!")
		    continue

                fn = "%s/Documents/EULA%s" % (url, suffix)
	        log("read url %s", fn)
                tries = 0
		file = None
                while tries < 5:
                    try:
                        file = urllib2.urlopen(fn)
                    except urllib2.HTTPError, e:
                        log("HTTPError: %s occurred getting %s", fn, e)
                    except urllib2.URLError, e:
                        log("URLError: %s occurred getting %s", fn, e)
                    except IOError, (errnum, msg):
                        log("IOError %s occurred getting %s: %s", fn,
                            errnum, str(msg))
                    except OSError, (errnum, msg):
                        log("OSError %s occurred getting %s: %s", fn,
                            errnum, str(msg))
                    else:
			log("no such file")
                        break

                    time.sleep(5)
                    tries = tries + 1

		if file != None:
                    if suffix.endswith('.html'):
                        buffer = htmlbuffer.HTMLBuffer()
                        buffer.feed(file.read())
                        self.releaseNotesBuffer = buffer.get_buffer()
                    else:
                        buffer = gtk.TextBuffer(None)
                        buffer.set_text(file.read())
                        self.releaseNotesBuffer = buffer
                    file.close()
		    getFlag = 1
		    break

        if flag == 'mount':
            try:
                self.dispatch.method.umountMedia()
            except:
                pass

	if getFlag == 0:
            buffer = gtk.TextBuffer(None)
            buffer.set_text(_("License Agreement Terms are not available now.\n"))
            self.releaseNotesBuffer = buffer

    def getScreen (self, intf, id, dispatch):
	self.intf = intf
	self.id = id
	self.dispatch = dispatch
	self.releaseNotesBuffer = None
	self.loadAgreement()
	html = TextViewBrowser()
	html.set_buffer(self.releaseNotesBuffer)
        sw = gtk.ScrolledWindow()
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        sw.set_shadow_type(gtk.SHADOW_IN)
        sw.add(html)

        box = gtk.VBox (gtk.FALSE, 5)
	box.pack_start (sw)
        #box.pack_start (gtk.HSeparator(), gtk.FALSE, padding=3)

	radiobox = gtk.HBox (gtk.FALSE)
	radiobox.set_spacing (50)
	labelSpace = gtk.Label("        ")	

	self.uselessbutton = gtk.RadioButton(None, "Useless")

	self.yesbutton = gtk.RadioButton(self.uselessbutton, _("_Accept"))
	self.yesbutton.set_size_request (120, -1)
	self.yesbutton.connect("toggled", self.yesbuttonCallback)

	self.nobutton = gtk.RadioButton(self.uselessbutton, _("No_t accept"))
	self.nobutton.set_size_request (120, -1)
	self.nobutton.connect("toggled", self.nobuttonCallback);

	if self.dispatch.id.accept == 1:
	    self.yesbutton.set_active(1)

	if self.dispatch.id.accept == 0:
	    self.nobutton.set_active(1)

	radiobox.pack_start(labelSpace, gtk.FALSE, gtk.FALSE)
        radiobox.pack_start(self.yesbutton, gtk.FALSE, gtk.FALSE)
	radiobox.pack_start(self.nobutton, gtk.FALSE, gtk.FALSE)
	box.pack_start (radiobox, gtk.FALSE, padding = 12)

        return box

