from installclass import BaseInstallClass
from rhpl.translate import N_, _

import os
import iutil

class InstallClass(BaseInstallClass):
    name = N_("Upgrade Existing System")
    pixmap = "upgrade.png"
    sortPriority = 999999

    parentClass = ( _("Upgrade"), "upgrade.png" )

    def requiredDisplayMode(self):
        return 't'

    def setSteps(self, dispatch):
	dispatch.setStepList(
		    "language",
		    "agreement",
		    "keyboard",
		    "welcome",
		    "installtype",
                    "findrootparts",
		    "findinstall",
		    "indexmark1",
                    "partitionobjinit",
                    "upgrademount",
                    "upgrademigfind",
                    "upgrademigratefs",
                    "upgradecontinue",
                    "readcomps",
                    #"findpackages",
                    "upgbootloader",
                    #"checkdeps",
		    #"dependencies",
		    #"confirmupgrade",
		    "indexmark2",
		    #"install",
                    #"migratefilesystems",
                    "preinstallconfig",
                    #"installpackages",
                    #"postinstallconfig",
		    "restorebootloader",
                    "instbootloader",
                    #"dopostaction",
                    "methodcomplete",
                    "copylogs",
		    "complete"
		)

        if iutil.getPPCMachine() == "iSeries":
            dispatch.skipStep("bootloadersetup", skip = 0)

        if iutil.getArch() != "i386" and iutil.getArch() != "x86_64":
            dispatch.skipStep("bootloader")
            dispatch.skipStep("bootloaderadvanced")

        if iutil.getArch() != "i386" and iutil.getArch() != "x86_64":
            dispatch.skipStep("upgbootloader")            

        dispatch.id.ISA['second'] = 'indexmark1'
        dispatch.id.ISA['third'] = 'readcomps'
        dispatch.id.ISA['fourth'] = 'indexmark2'
        dispatch.id.ISB['third'] = 'indexmark2'

    def setInstallData(self, id):
        BaseInstallClass.setInstallData(self, id)
        id.upgrade.set(1)
    
    def __init__(self, expert):
	BaseInstallClass.__init__(self, expert)
